depends 'research_paths'
depends 'research_path_queries'
depends 'choose_research'
depends 'research_desires'


local basic_priorities = {
  'Guidance Systems',
  'Lasers',
  'Retargeting Systems' ,
  'Self-Organizing Networks',
  'Nanoscale Fabrication',
  'Defense Grid',
  'Missile Cruiser',
  'Escort Cruiser',
  'Heavy Hulls',
  'Heavy Lasers',
  'Hyperspace Beacons',
  'Duranium Construction',
  'Heavy Ion Beams',
  'Habitat Domes',
  'Carriers',
  'Disruptors',
  'Hyperspace Metrics',
  'Battlecruiser',
  'Carriers',
  'Dreadnoughts',
  'Hellbore Cannon',
}

function handle.tech(r)

  --print('handling tech report',r)

  local priorities = basic_priorities
  local tech in r.empire!

  local t = choose_next_research(r.empire)
  if t
    order.set_research(r.empire, tech:get_candidate_queue(t) )
    goto done
  end

  --fallback
  for i,t in ipairs | priorities
    if not tech.info[t]
      goto next
    elseif not tech.known[t]
      local queue = tech:get_candidate_queue(t)
      if queue and next | queue
        order.set_research(r.empire, tech:get_candidate_queue(t) )
        goto done
      end
     
    end

    ::next::
  end 


  ::done::
  -- 
  --print('doing redesign')
  redesign_ships(r.empire)
end

handle.research_ready = handle.tech